---
title: Merge Question Values
product: Form Library
description: Split your complex forms into multiple parts and link them with each other to save survey results in a single object or array. View a free demo for JavaScript to learn more.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/merge-question-values/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Merge Question Values (Vanilla JS)

You can merge values from multiple questions into a single array or object. This functionality enables you to split complex forms into connected parts. For example, you can create a form where users enter a list of employees in one question and fill out details about them in a dedicated section of questions that generates dynamically once a new employer has been added to the list. If you link the questions with each other, their values will be merged into a single array.

## Associate Compatible Questions

To link two questions, set their [`valueName`](https://surveyjs.io/form-library/documentation/api-reference/question#valueName) property to the same value. This value will be used as a name for the property that will contain the merged array. In this demo, the employment history form contains two questions of the [Dynamic Matrix](https://surveyjs.io/form-library/documentation/api-reference/dynamic-matrix-table-question-model) and [Dynamic Panel](https://surveyjs.io/form-library/documentation/api-reference/dynamic-panel-model) types. Respondents enter a list of employer names into the matrix and details about each employer into multiple panels. Together, Dynamic Matrix and Dynamic Panel produce an `employees` array of objects. The matrix supplies the `employee-name` field values; the panel supplies the remaining field values. Once bound via `valueName`, two questions can reference each other's values. For example, values from the matrix can be displayed in panel headers, as shown in this demo.

## Associate Incompatible Questions

Dynamic Matrix and Dynamic Panel are compatible because they both produce arrays of objects when they are used as standalone questions. In some instances, you need to associate two or more questions that produce results in different formats and as such are incompatible. For example, the Checkboxes question type produces an array of primitive values, and a primitive value cannot be merged with an object. To force a Checkboxes question to produce an array of objects, specify the [`valuePropertyName`](https://surveyjs.io/form-library/documentation/api-reference/checkbox-question-model#valuePropertyName) property with a field name that should store question values.

In this demo, on the second survey page respondents are asked about their language skills. Respondents should select languages they speak from a Checkboxes question. For each selected language, a Dynamic Panel question generates a detail panel. The two questions are associated via `valueName`, and the Checkboxes question produces an array of objects. The `language` object field stores the selected language. This field is used to reference languages in panel headers.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "title": "Employment History",
  "pages": [
    {
      "name": "employers-page",
      "elements": [
        {
          "type": "matrixdynamic",
          "name": "employerNames",
          "title": "Please add your previous and current employers",
          "valueName": "employers",
          "isRequired": true,
          "showHeader": false,
          "columns": [
            {
              "name": "employee-name",
              "cellType": "text",
              "isRequired": true
            }
          ],
          "rowCount": 1,
          "minRowCount": 1,
          "addRowText": "Add Employer"
        },
        {
          "type": "paneldynamic",
          "name": "employers_info",
          "title": "Details",
          "valueName": "employers",
          "templateElements": [
            {
              "type": "panel",
              "name": "panel_employer_address",
              "elements": [
                {
                  "type": "text",
                  "name": "jobTitle",
                  "title": "Job Title",
                  "titleLocation": "left"
                },
                {
                  "type": "text",
                  "name": "city",
                  "startWithNewLine": false,
                  "title": "City",
                  "titleLocation": "left"
                },
                {
                  "type": "panel",
                  "name": "workingDate",
                  "elements": [
                    {
                      "type": "text",
                      "name": "startDate",
                      "title": "Start Date",
                      "titleLocation": "left",
                      "inputType": "month",
                      "validators": [
                        {
                          "type": "expression",
                          "text": "The value should not be less than the current date",
                          "expression": "getDate({panel.startDate}) < currentDate()"
                        }
                      ]
                    },
                    {
                      "type": "text",
                      "name": "endDate",
                      "title": "End Date",
                      "titleLocation": "left",
                      "validators": [
                        {
                          "type": "expression",
                          "text": "The value should not be less than a start date",
                          "expression": "getDate({panel.endDate}) > getDate({panel.startDate})"
                        }
                      ],
                      "inputType": "month"
                    }
                  ]
                },
                {
                  "type": "comment",
                  "name": "jobDescription",
                  "startWithNewLine": false,
                  "title": "Description",
                  "description": "Describe your achievements. If possible, use numbers/facts (e.g., Achieved X, Measured by Y)",
                  "placeholder": "e.g. Implemented a new digital marketing strategy that increased website traffic by 50% and improved lead generation by 30% over a period of six months.",
                  "autoGrow": true
                }
              ]
            }
          ],
          "templateTitle": "Employer: {panel.employee-name}",
          "allowAddPanel": false,
          "allowRemovePanel": false
        }
      ],
      "description": "Please provide necessary information about your relevant experience. Click the Add Employer button below and enter the information about your employer. Fill out the additional fields in the form provided."
    },
    {
      "name": "language-page",
      "elements": [
        {
          "type": "checkbox",
          "name": "languages",
          "title": "Please select all languages that you are proficient in.",
          "isRequired": true,
          "choices": [
            "English",
            "German",
            "Chinese",
            "French",
            "Japanese"
          ],          
          "valuePropertyName": "language"
        },
        {
          "type": "paneldynamic",
          "name": "languageInfo",
          "title": "Additional Details",
          "valueName": "languages",
          "templateElements": [
            {
              "type": "rating",
              "name": "level",
              "title": "Level of proficiency:",
              "rateValues": [
                "Beginner",
                "Intermediate",
                "Advanced",
                "Expert"
              ]
            },
            {
              "type": "text",
              "name": "experience",
              "startWithNewLine": false,
              "title": "Years of experience:",
              "titleLocation": "left",
              "inputType": "number",
              "min": 1
            }
          ],
          "templateTitle": "Language: {panel.language}",
          "allowAddPanel": false,
          "allowRemovePanel": false
        }
      ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/merge-question-values/angular.md)
- [React](https://surveyjs.io/form-library/examples/merge-question-values/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/merge-question-values/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/merge-question-values/jquery.md)


---
title: Merge Question Values
product: Form Library
description: Split your complex forms into multiple parts and link them with each other to save survey results in a single object or array. View a free demo for JavaScript to learn more.
framework: React
source: https://surveyjs.io/form-library/examples/merge-question-values/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Merge Question Values (React)

You can merge values from multiple questions into a single array or object. This functionality enables you to split complex forms into connected parts. For example, you can create a form where users enter a list of employees in one question and fill out details about them in a dedicated section of questions that generates dynamically once a new employer has been added to the list. If you link the questions with each other, their values will be merged into a single array.

## Associate Compatible Questions

To link two questions, set their [`valueName`](https://surveyjs.io/form-library/documentation/api-reference/question#valueName) property to the same value. This value will be used as a name for the property that will contain the merged array. In this demo, the employment history form contains two questions of the [Dynamic Matrix](https://surveyjs.io/form-library/documentation/api-reference/dynamic-matrix-table-question-model) and [Dynamic Panel](https://surveyjs.io/form-library/documentation/api-reference/dynamic-panel-model) types. Respondents enter a list of employer names into the matrix and details about each employer into multiple panels. Together, Dynamic Matrix and Dynamic Panel produce an `employees` array of objects. The matrix supplies the `employee-name` field values; the panel supplies the remaining field values. Once bound via `valueName`, two questions can reference each other's values. For example, values from the matrix can be displayed in panel headers, as shown in this demo.

## Associate Incompatible Questions

Dynamic Matrix and Dynamic Panel are compatible because they both produce arrays of objects when they are used as standalone questions. In some instances, you need to associate two or more questions that produce results in different formats and as such are incompatible. For example, the Checkboxes question type produces an array of primitive values, and a primitive value cannot be merged with an object. To force a Checkboxes question to produce an array of objects, specify the [`valuePropertyName`](https://surveyjs.io/form-library/documentation/api-reference/checkbox-question-model#valuePropertyName) property with a field name that should store question values.

In this demo, on the second survey page respondents are asked about their language skills. Respondents should select languages they speak from a Checkboxes question. For each selected language, a Dynamic Panel question generates a detail panel. The two questions are associated via `valueName`, and the Checkboxes question produces an array of objects. The `language` object field stores the selected language. This field is used to reference languages in panel headers.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "title": "Employment History",
  "pages": [
    {
      "name": "employers-page",
      "elements": [
        {
          "type": "matrixdynamic",
          "name": "employerNames",
          "title": "Please add your previous and current employers",
          "valueName": "employers",
          "isRequired": true,
          "showHeader": false,
          "columns": [
            {
              "name": "employee-name",
              "cellType": "text",
              "isRequired": true
            }
          ],
          "rowCount": 1,
          "minRowCount": 1,
          "addRowText": "Add Employer"
        },
        {
          "type": "paneldynamic",
          "name": "employers_info",
          "title": "Details",
          "valueName": "employers",
          "templateElements": [
            {
              "type": "panel",
              "name": "panel_employer_address",
              "elements": [
                {
                  "type": "text",
                  "name": "jobTitle",
                  "title": "Job Title",
                  "titleLocation": "left"
                },
                {
                  "type": "text",
                  "name": "city",
                  "startWithNewLine": false,
                  "title": "City",
                  "titleLocation": "left"
                },
                {
                  "type": "panel",
                  "name": "workingDate",
                  "elements": [
                    {
                      "type": "text",
                      "name": "startDate",
                      "title": "Start Date",
                      "titleLocation": "left",
                      "inputType": "month",
                      "validators": [
                        {
                          "type": "expression",
                          "text": "The value should not be less than the current date",
                          "expression": "getDate({panel.startDate}) < currentDate()"
                        }
                      ]
                    },
                    {
                      "type": "text",
                      "name": "endDate",
                      "title": "End Date",
                      "titleLocation": "left",
                      "validators": [
                        {
                          "type": "expression",
                          "text": "The value should not be less than a start date",
                          "expression": "getDate({panel.endDate}) > getDate({panel.startDate})"
                        }
                      ],
                      "inputType": "month"
                    }
                  ]
                },
                {
                  "type": "comment",
                  "name": "jobDescription",
                  "startWithNewLine": false,
                  "title": "Description",
                  "description": "Describe your achievements. If possible, use numbers/facts (e.g., Achieved X, Measured by Y)",
                  "placeholder": "e.g. Implemented a new digital marketing strategy that increased website traffic by 50% and improved lead generation by 30% over a period of six months.",
                  "autoGrow": true
                }
              ]
            }
          ],
          "templateTitle": "Employer: {panel.employee-name}",
          "allowAddPanel": false,
          "allowRemovePanel": false
        }
      ],
      "description": "Please provide necessary information about your relevant experience. Click the Add Employer button below and enter the information about your employer. Fill out the additional fields in the form provided."
    },
    {
      "name": "language-page",
      "elements": [
        {
          "type": "checkbox",
          "name": "languages",
          "title": "Please select all languages that you are proficient in.",
          "isRequired": true,
          "choices": [
            "English",
            "German",
            "Chinese",
            "French",
            "Japanese"
          ],          
          "valuePropertyName": "language"
        },
        {
          "type": "paneldynamic",
          "name": "languageInfo",
          "title": "Additional Details",
          "valueName": "languages",
          "templateElements": [
            {
              "type": "rating",
              "name": "level",
              "title": "Level of proficiency:",
              "rateValues": [
                "Beginner",
                "Intermediate",
                "Advanced",
                "Expert"
              ]
            },
            {
              "type": "text",
              "name": "experience",
              "startWithNewLine": false,
              "title": "Years of experience:",
              "titleLocation": "left",
              "inputType": "number",
              "min": 1
            }
          ],
          "templateTitle": "Language: {panel.language}",
          "allowAddPanel": false,
          "allowRemovePanel": false
        }
      ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/merge-question-values/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/merge-question-values/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/merge-question-values/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/merge-question-values/vanillajs.md)


---
title: Merge Question Values
product: Form Library
description: Split your complex forms into multiple parts and link them with each other to save survey results in a single object or array. View a free demo for JavaScript to learn more.
framework: Angular
source: https://surveyjs.io/form-library/examples/merge-question-values/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Merge Question Values (Angular)

You can merge values from multiple questions into a single array or object. This functionality enables you to split complex forms into connected parts. For example, you can create a form where users enter a list of employees in one question and fill out details about them in a dedicated section of questions that generates dynamically once a new employer has been added to the list. If you link the questions with each other, their values will be merged into a single array.

## Associate Compatible Questions

To link two questions, set their [`valueName`](https://surveyjs.io/form-library/documentation/api-reference/question#valueName) property to the same value. This value will be used as a name for the property that will contain the merged array. In this demo, the employment history form contains two questions of the [Dynamic Matrix](https://surveyjs.io/form-library/documentation/api-reference/dynamic-matrix-table-question-model) and [Dynamic Panel](https://surveyjs.io/form-library/documentation/api-reference/dynamic-panel-model) types. Respondents enter a list of employer names into the matrix and details about each employer into multiple panels. Together, Dynamic Matrix and Dynamic Panel produce an `employees` array of objects. The matrix supplies the `employee-name` field values; the panel supplies the remaining field values. Once bound via `valueName`, two questions can reference each other's values. For example, values from the matrix can be displayed in panel headers, as shown in this demo.

## Associate Incompatible Questions

Dynamic Matrix and Dynamic Panel are compatible because they both produce arrays of objects when they are used as standalone questions. In some instances, you need to associate two or more questions that produce results in different formats and as such are incompatible. For example, the Checkboxes question type produces an array of primitive values, and a primitive value cannot be merged with an object. To force a Checkboxes question to produce an array of objects, specify the [`valuePropertyName`](https://surveyjs.io/form-library/documentation/api-reference/checkbox-question-model#valuePropertyName) property with a field name that should store question values.

In this demo, on the second survey page respondents are asked about their language skills. Respondents should select languages they speak from a Checkboxes question. For each selected language, a Dynamic Panel question generates a detail panel. The two questions are associated via `valueName`, and the Checkboxes question produces an array of objects. The `language` object field stores the selected language. This field is used to reference languages in panel headers.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "title": "Employment History",
  "pages": [
    {
      "name": "employers-page",
      "elements": [
        {
          "type": "matrixdynamic",
          "name": "employerNames",
          "title": "Please add your previous and current employers",
          "valueName": "employers",
          "isRequired": true,
          "showHeader": false,
          "columns": [
            {
              "name": "employee-name",
              "cellType": "text",
              "isRequired": true
            }
          ],
          "rowCount": 1,
          "minRowCount": 1,
          "addRowText": "Add Employer"
        },
        {
          "type": "paneldynamic",
          "name": "employers_info",
          "title": "Details",
          "valueName": "employers",
          "templateElements": [
            {
              "type": "panel",
              "name": "panel_employer_address",
              "elements": [
                {
                  "type": "text",
                  "name": "jobTitle",
                  "title": "Job Title",
                  "titleLocation": "left"
                },
                {
                  "type": "text",
                  "name": "city",
                  "startWithNewLine": false,
                  "title": "City",
                  "titleLocation": "left"
                },
                {
                  "type": "panel",
                  "name": "workingDate",
                  "elements": [
                    {
                      "type": "text",
                      "name": "startDate",
                      "title": "Start Date",
                      "titleLocation": "left",
                      "inputType": "month",
                      "validators": [
                        {
                          "type": "expression",
                          "text": "The value should not be less than the current date",
                          "expression": "getDate({panel.startDate}) < currentDate()"
                        }
                      ]
                    },
                    {
                      "type": "text",
                      "name": "endDate",
                      "title": "End Date",
                      "titleLocation": "left",
                      "validators": [
                        {
                          "type": "expression",
                          "text": "The value should not be less than a start date",
                          "expression": "getDate({panel.endDate}) > getDate({panel.startDate})"
                        }
                      ],
                      "inputType": "month"
                    }
                  ]
                },
                {
                  "type": "comment",
                  "name": "jobDescription",
                  "startWithNewLine": false,
                  "title": "Description",
                  "description": "Describe your achievements. If possible, use numbers/facts (e.g., Achieved X, Measured by Y)",
                  "placeholder": "e.g. Implemented a new digital marketing strategy that increased website traffic by 50% and improved lead generation by 30% over a period of six months.",
                  "autoGrow": true
                }
              ]
            }
          ],
          "templateTitle": "Employer: {panel.employee-name}",
          "allowAddPanel": false,
          "allowRemovePanel": false
        }
      ],
      "description": "Please provide necessary information about your relevant experience. Click the Add Employer button below and enter the information about your employer. Fill out the additional fields in the form provided."
    },
    {
      "name": "language-page",
      "elements": [
        {
          "type": "checkbox",
          "name": "languages",
          "title": "Please select all languages that you are proficient in.",
          "isRequired": true,
          "choices": [
            "English",
            "German",
            "Chinese",
            "French",
            "Japanese"
          ],          
          "valuePropertyName": "language"
        },
        {
          "type": "paneldynamic",
          "name": "languageInfo",
          "title": "Additional Details",
          "valueName": "languages",
          "templateElements": [
            {
              "type": "rating",
              "name": "level",
              "title": "Level of proficiency:",
              "rateValues": [
                "Beginner",
                "Intermediate",
                "Advanced",
                "Expert"
              ]
            },
            {
              "type": "text",
              "name": "experience",
              "startWithNewLine": false,
              "title": "Years of experience:",
              "titleLocation": "left",
              "inputType": "number",
              "min": 1
            }
          ],
          "templateTitle": "Language: {panel.language}",
          "allowAddPanel": false,
          "allowRemovePanel": false
        }
      ]
    }
  ]
};
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/merge-question-values/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/merge-question-values/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/merge-question-values/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/merge-question-values/vanillajs.md)
